= nng_aio_stop(3)
//
// Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_aio_stop - stop asynchronous I/O operation

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

void nng_aio_stop(nng_aio *aio);
----

== DESCRIPTION

The `nng_aio_stop()` function stops the asynchronous I/O operation
associated with _aio_ by aborting with `NNG_ECANCELED`, and then waits
for it to complete or to be completely aborted, and for the
callback associated with the _aio_ to have completed executing.

Further calls to
xref:nng_aio_begin.3.adoc[`nng_aio_begin()`] using this _aio_ will return false.

It is safe to call this for an _aio_, even when no operation is currently
pending for it.

TIP: When multiple asynchronous I/O handles are in use and need to be
shut down, it is safest to stop all of them, before deallocating any of
them with xref:nng_aio_free.3.adoc[`nng_aio_free()`], particularly if the callbacks
might attempt to reschedule additional operations.

== RETURN VALUES

None.

== ERRORS

None.

== SEE ALSO

[.text-left]
xref:nng_aio_alloc.3.adoc[nng_aio_alloc(3)],
xref:nng_aio_cancel.3.adoc[nng_aio_cancel(3)],
xref:nng_aio_free.3.adoc[nng_aio_free(3)],
xref:nng_aio_begin.3.adoc[nng_aio_begin(3)],
xref:nng_aio_wait.3.adoc[nng_aio_wait(3)],
xref:nng_aio.5.adoc[nng_aio(5)],
xref:nng.7.adoc[nng(7)]
